
  <!DOCTYPE html>
  <html>
    <head>
      <title>FormContext.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/pages/project-settings/components/FormContext.tsx</td><td class="">97.63%</td><td class="">80%</td><td class="">338</td><td class="">330</td><td class="">8</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useContext, useEffect, useState } from &#x27;react&#x27;;

export type IntSpec = {
  name: string;
  type: &#x27;int&#x27;;
  min?: number;
  max?: number;
  defaultValue?: number;
  required?: boolean;
};

export type FloatSpec = {
  name: string;
  type: &#x27;float&#x27;;
  min?: number;
  max?: number;
  defaultValue?: number;
  required?: boolean;
};

export type RadioSpec = {
  name: string;
  title: string;
  type: &#x27;radio&#x27;;
  options: { value: string; label: string }[];
  defaultValue?: string;
  required?: boolean;
};
export type FieldSpec = IntSpec | FloatSpec | RadioSpec;

export const FormContext = React.createContext({
  fieldsSpec: [] as FieldSpec[],
  values: {} as { [key: string]: any },
  errors: {} as { [key: string]: string },
  onSetErrors: (errors: { [key: string]: string }) =&gt; {},
  onChangeField(field: string, value: any) {}
});

export const useFormField = (fieldName: string) =&gt; {
  const ctx = useContext(FormContext);
  return {
    value: ctx.values[fieldName],
    onChange: ctx.onChangeField
  };
};

const useFormContextValues = () =&gt; useContext(FormContext).values;
const useFieldsSpec = () =&gt; useContext(FormContext).fieldsSpec;
const useSetErrors = () =&gt; useContext(FormContext).onSetErrors;
const useOnChangeField = () =&gt; useContext(FormContext).onChangeField;
const useErrors = () =&gt; useContext(FormContext).errors;
const useTitle = (fieldName: string) =&gt;
  (
    useContext(FormContext).fieldsSpec.find(
      ({ name }) =&gt; name === fieldName
    ) as RadioSpec
  ).title;
const useOptions = (fieldName: string) =&gt; {
  return (
    useContext(FormContext).fieldsSpec.find(
      ({ name }) =&gt; name === fieldName
    ) as RadioSpec
  ).options;
};

const validateInt = (spec: IntSpec, value: number | string) =&gt; {
  if (typeof value !== &#x27;number&#x27;) {
    return {
      [spec.name]: `Field should be number`
    };
  }
  const errors: { [key: string]: string } = {};
  if ((value * 10) % 10 !== 0) {
    errors[spec.name] = `Field should be integer`;
  }
  if (typeof spec.min === &#x27;number&#x27; &amp;&amp; spec.min &gt; value) {
    errors[spec.name] = `Field should be greater than ${spec.min}`;
  }
  if (typeof spec.max === &#x27;number&#x27; &amp;&amp; spec.max &lt; value) {
    errors[spec.name] = `Field should be less than ${spec.max}`;
  }
  return errors;
};

const validateFloat = (spec: FloatSpec, value: number | string) =&gt; {
  const errors: { [key: string]: string } = {};
  if (typeof value !== &#x27;number&#x27;) {
    return {
      [spec.name]: `Field should be number`
    };
  }
  if (typeof spec.min === &#x27;number&#x27; &amp;&amp; spec.min &gt; value) {
    errors[spec.name] = `Field should be greater than ${spec.min}`;
  }
  if (typeof spec.max === &#x27;number&#x27; &amp;&amp; spec.max &lt; value) {
    errors[spec.name] = `Field should be less than ${spec.max}`;
  }
  return errors;
};

const validateRadio = (spec: RadioSpec, value: string | number) =&gt; {
  if (typeof value !== &#x27;string&#x27;) {
    return {
      [spec.name]: `Field should be string`
    };
  }
  const errors: { [key: string]: string } = {};
  if (!spec.options.find((opt) =&gt; opt.value === value)) {
    errors[spec.name] = `Field must be one of this options: ${spec.options.join(
      &#x27;, &#x27;
    )}`;
  }
  return errors;
};
const validateRequired = (spec: FieldSpec, value?: string | number) =&gt; {
  if (spec.required &amp;&amp; typeof value === &#x27;undefined&#x27;) {
    return {
      [spec.name]: &#x27;Field required&#x27;
    };
  }
  return {};
};
const validateFieldsBySpec = (
  fieldsSpec: FieldSpec[],
  values: { [key: string]: any }
) =&gt; {
  let errors: { [key: string]: string } = {};
  fieldsSpec.forEach((spec) =&gt; {
    const currentValue = values[spec.name];
    if (spec.type === &#x27;int&#x27;) {
      errors = { ...errors, ...validateInt(spec, currentValue) };
    } else if (spec.type === &#x27;float&#x27;) {
      errors = { ...errors, ...validateFloat(spec, currentValue) };
    } else if (spec.type === &#x27;radio&#x27;) {
      errors = { ...errors, ...validateRadio(spec, currentValue) };
    }
    errors = { ...errors, ...validateRequired(spec, currentValue) };
  });
  return errors;
};
export const useValidate = () =&gt; {
  const values = useFormContextValues();
  const fieldsSpec = useFieldsSpec();
  const onSetErrors = useSetErrors();
  return useCallback(() =&gt; {
    const errors = validateFieldsBySpec(fieldsSpec, values);
    onSetErrors(errors);
    return errors;
  }, [fieldsSpec, onSetErrors, values]);
};

export const useField = (fieldName: string) =&gt; {
  const values = useFormContextValues();
  const errors = useErrors();
  const onChange = useOnChangeField();
  const options = useOptions(fieldName);
  const title = useTitle(fieldName);
  return {
    value: values[fieldName],
    error: errors[fieldName],
    onChange: (value?: string | number) =&gt; onChange(fieldName, value),
    options,
    title
  };
};

export const FormWrapper: React.FC&lt;{
  defaultValues: { [key: string]: any };
  fieldsSpec: FieldSpec[];
  fields: { [key: string]: any };
  setFields: (
    fields:
      | { [key: string]: any }
      | ((fields: { [key: string]: any }) =&gt; { [key: string]: any })
  ) =&gt; void;
}&gt; = ({ fields, setFields, defaultValues = {}, fieldsSpec, children }) =&gt; {
  useEffect(() =&gt; {
    setFields(defaultValues);
  }, [defaultValues, setFields]);
  const [errors, setErrors] = useState&lt;{ [key: string]: string }&gt;({});
  const onChangeField = useCallback(
    (field: string, value: any) =&gt; {
      setErrors({});
      setFields((prev) =&gt; ({ ...prev, [field]: value }));
    },
    [setFields]
  );
  return (
    &lt;FormContext.Provider
      value={{
        fieldsSpec,
        values: fields,
        errors,
        onSetErrors: setErrors,
        onChangeField
      }}
    &gt;
      {children}
    &lt;/FormContext.Provider&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:35,&quot;character&quot;:31,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:41,&quot;character&quot;:4,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:53,&quot;character&quot;:4,&quot;text&quot;:&quot;useContext(FormContext).fieldsSpec.find(\n      ({ name }) =&gt; name === fieldName\n    ) as RadioSpec&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:59,&quot;character&quot;:4,&quot;text&quot;:&quot;useContext(FormContext).fieldsSpec.find(\n      ({ name }) =&gt; name === fieldName\n    ) as RadioSpec&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:128,&quot;character&quot;:10,&quot;text&quot;:&quot;currentValue&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:158,&quot;character&quot;:4,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:181,&quot;character&quot;:20,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/components/FormContext.tsx&quot;,&quot;line&quot;:183,&quot;character&quot;:47,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  